# linux-cip-ci
[![pipeline status](https://gitlab.com/cip-project/cip-testing/linux-cip-ci/badges/master/pipeline.svg)](https://gitlab.com/cip-project/cip-testing/linux-cip-ci/commits/master)

Current DOCKER_IMAGE_TAG version: v3

This project builds the containers and scripts used in the CI testing of the
linux-cip Kernel.

There are two docker containers, "build-image" and "test-image". You can guess
what they are for.

## build-image
Docker container that includes Linux Kernel build dependencies.

Also included is the `build_kernel.sh` script which handles the actual building
of the Kernel for the given architecture and configurations.

### build_kernel.sh
This script starts by installing the relevant gcc compiler for the given
architecture. It then builds the Kernel, device trees and modules as required
for the given configuration.

The GitLab CI configuration then archives the relevant binaries ready for the
test stage to pick up.

**Parameters**  
The following variables should be set in the gitlab-ci.yml job:  
* `BUILD_ARCH`: The architecture to build for. Architectures currently supported
are: arm, arm64, powerpc, x86.
* `CONFIG`: The name of the configuration file to be used. Can be in either
.config or defconfig format.
* `CONFIG_LOC`: Must be one of the following options:
  * `intree`: Configuration is present in the linux-cip Kernel.
  * `cip-kernel-configs`: Configuration is present in the [cip-kernel-configs](https://gitlab.com/cip-project/cip-kernel/cip-kernel-config) repository.
  * `url`: Download configuration from public URL set by an additional variable
called `CONFIG_URL`. The link should be to the directory where the config is
stored, not the actual file.

### create_stable_commit.sh
This is a simple script that will take the information from a provided commit
message (provided in a file generated by `git log -1 <commit> > <file>` and add
it to a new commit in the current repository. The new commit will consist of the
provided file.

The author and summary information of the new commit will match the original
commit, however the date/time and SHA will differ.

The script assumes that it is running in the relevant git repository directory.

This script is useful for the stable-rc CI testing, as it helps identify what
commit is being tested (the source code is kept in a seperate reporitory to the
GitLab CI pipelines).

## test-image
Used to build a container that includes the dependencies required for testing.

Also included is the `submit_tests.sh` script which creates and submits LAVA
test jobs.

### submit_tests.sh
This script starts by searching for Kernels that are in the `$OUTPUT_DIR`
directory. Each Kernel then gets uploaded to an S3 bucket on AWS. The script
then creates LAVA test jobs as required and submits them to the CIP LAVA master.

**Prerequisites**  
The `submit_tests.sh` script relies on the following secret environment
variables being set. This can be done in GitLab in `settings/ci_cd`.
* `CIP_CI_AWS_ID`
* `CIP_CI_AWS_KEY`
* `CIP_LAVA_LAB_USER`
* `CIP_LAVA_LAB_TOKEN`

**Parameters**  
* `TEST_TIMEOUT`: Length of time in minutes to wait for test completion. If
unset then no timeout is used.
* `SUBMIT_ONLY`: Set to 'true' if you don't want to wait to see if submitted
LAVA jobs complete. If this is not set a default of 'false' is used.
* `BUILD_ARCH`: The architecture used in the build job. Required to help with
directory navigation.
* `CONFIG`: The name of the configuration file used in the build job. Required
to help with directory navigation.
* `DEVICES`: A list of device-types as defined in LAVA that are to be tested.
* `DTBS`: A list of device tree blobs (including extension) that are to be used
in testing. There are three ways to use/not use this parameter:
  * Not define it at all. This is okay as not all devices use device trees.
  * If multiple devices are defined, define one dtb per device. They will be
mapped on a one-to-one basis.
  * If only one device is defined, one or many dtbs may be defined. They will
all be used on the specified device.
* `TESTS`: A list of test cases to run for each device/dtb combo. Currently
supported tests are:
  * `boot`: A simple boot test that prints the Kernel version.
  * `smc`: A Spectre/Meltdown vulnerability checker.
  * `ltp`: Runs through all supported tests from the Linux Test Project test
suit including ltp-cve-tests, ltp-dio-tests, ltp-fs-tests, ltp-ipc-tests,
ltp-math-tests, ltp-sched-tests, ltp-syscalls-tests and ltp-timers-tests.
  * `ltp-[TEST]`: Specify an individual test from the list of LTP tests above.

## linux-cip-ci version
Wherever possible when changes are made to the containers and scripts in
linux-cip-ci, care is taken not to break backwards compatibility. Sometimes this
is not possible so a `DOCKER_IMAGE_TAG` variable has been created.

Each time there is a breaking change this variable is incremented in the
.gitlab-ci.yml file in the linux-cip-ci repository.

## Example Use
The below `.gitlab-ci.yml` file shows how linux-cip-ci can be used.

```
variables:
  GIT_STRATEGY: clone
  GIT_DEPTH: "10"
  DOCKER_DRIVER: overlay2
  DOCKER_IMAGE_TAG: v3

build:arm_shmobile_defconfig:
  stage: build
  image: registry.gitlab.com/cip-project/cip-testing/linux-cip-ci:build-$DOCKER_IMAGE_TAG
  variables:
    BUILD_ARCH: arm
    CONFIG: shmobile_defconfig
    CONFIG_LOC: intree
  script:
    - /opt/build_kernel.sh
  artifacts:
    name: "$CI_JOB_NAME"
    when: always
    paths:
      - output

test:arm_shmobile_defconfig:
  stage: test
  needs: ["build:arm_shmobile_defconfig"]
  image: registry.gitlab.com/cip-project/cip-testing/linux-cip-ci:test-$DOCKER_IMAGE_TAG
  variables:
    GIT_STRATEGY: none
    BUILD_ARCH: arm
    CONFIG: shmobile_defconfig
    DEVICES: r8a7743-iwg20d-q7 r8a7745-iwg22d-sodimm
    DTBS: r8a7743-iwg20d-q7-dbcm-ca.dtb r8a7745-iwg22d-sodimm-dbhd-ca.dtb
    TESTS: boot
  script:
    - /opt/submit_tests.sh
  artifacts:
    name: "$CI_JOB_NAME"
    when: always
    paths:
      - output

build:arm64_renesas_defconfig:
  stage: build
  image: registry.gitlab.com/cip-project/cip-testing/linux-cip-ci:build-$DOCKER_IMAGE_TAG
  variables:
    BUILD_ARCH: arm64
    CONFIG: renesas_defconfig
    CONFIG_LOC: cip-kernel-config
  script:
    - /opt/build_kernel.sh
  artifacts:
    name: "$CI_JOB_NAME"
    when: always
    paths:
      - output

test:arm64_renesas_defconfig:
  stage: test
  needs: ["build:arm64_defconfig"]
  image: registry.gitlab.com/cip-project/cip-testing/linux-cip-ci:test-$DOCKER_IMAGE_TAG
  variables:
    GIT_STRATEGY: none
    BUILD_ARCH: arm64
    CONFIG: renesas_defconfig
    DEVICES: r8a774a1-hihope-rzg2m-ex
    DTBS: r8a774a1-hihope-rzg2m-ex.dtb r8a774a1-hihope-rzg2m.dtb
    TESTS: boot smc ltp
  script:
    - /opt/submit_tests.sh
  artifacts:
    name: "$CI_JOB_NAME"
    when: always
    paths:
      - output

build:x86_siemens_server_defconfig:
  stage: build
  image: registry.gitlab.com/cip-project/cip-testing/linux-cip-ci:build-$DOCKER_IMAGE_TAG
  variables:
    BUILD_ARCH: x86
    CONFIG: siemens_server_defconfig
    CONFIG_LOC: cip-kernel-config
  script:
    - /opt/build_kernel.sh
  artifacts:
    name: "$CI_JOB_NAME"
    when: always
    paths:
      - output
```
